#ifndef CONSOLE_H
#define CONSOLE_H

#include <stdio.h>
#include <termios.h>
#include <unistd.h>
#include <fcntl.h>
#include <errno.h> 
#include <string.h>
#include <stdlib.h>
#include <iostream>

using namespace std;

#define CONSOLE_RED "\033[91m"
#define CONSOLE_GREEN "\033[92m"
#define CONSOLE_YELLOW "\033[93m"
#define CONSOLE_BLUE "\033[94m"
#define CONSOLE_BRIGHT_BLUE "\033[96m"
#define CONSOLE_ORANGE "\033[33m"
#define CONSOLE_COOL "\033[36m"

#define CONSOLE_RESET "\033[0m"

#define KEY_UP 65
#define KEY_DOWN 66
#define KEY_RIGHT 67
#define KEY_LEFT 68

#define fail() Fail(__LINE__,__FILE__);


bool keypress(){
    struct termios oldt, newt;
    int ch;
    int oldf;

    tcgetattr(STDIN_FILENO, &oldt);
    newt = oldt;
    newt.c_lflag &= ~(ICANON | ECHO);
    tcsetattr(STDIN_FILENO, TCSANOW, &newt);
    oldf = fcntl(STDIN_FILENO, F_GETFL, 0);
    fcntl(STDIN_FILENO, F_SETFL, oldf | O_NONBLOCK);

    ch = getchar();

    tcsetattr(STDIN_FILENO, TCSANOW, &oldt);
    fcntl(STDIN_FILENO, F_SETFL, oldf);

    if(ch != EOF){
        ungetc(ch, stdin);
        return true;
    }

    return false;
}

void Fail(int line,const string file){
    cout << CONSOLE_RED << strerror(errno) << endl;
    cout <<  "File " << CONSOLE_GREEN <<  file << CONSOLE_RED << "\nLine " << CONSOLE_GREEN << line << CONSOLE_RESET << endl;

    cout.flush();
    cerr.flush();
    exit(1);
}

#endif