#ifndef KINECT_H
#define KINECT_H

#include <cv.h>
#include <highgui.h>
#include <fstream>
#include <iostream>     // std::cout


using namespace std;
using namespace cv;

struct frame{
    Mat rgb,d;
};

float* readFloatFile(char* name,int len){
    float* res = new float[len];
    ifstream f(name,ios::binary);
    f.read((char*)res,sizeof(float)*len);
    f.close();
    return res;
}

void writeFloatFile(char* name,int len,float* res){
    ofstream f(name,ios::binary);
    f.write((char*)res,sizeof(float)*len);
    f.close();
}

class Kinect{
bool file;
char* path;
string out;
VideoCapture capture;
public:
int num;
    Kinect(char* buff = NULL){
        if(buff == NULL){
            file = false;
            retry:
            capture = VideoCapture(CV_CAP_OPENNI);
            if(!capture.isOpened()){
                cerr << "\033[1;31mKinect isn't plugged in!\033[0;0m\nIf you want to read frames from a folder run:    scanner 3D [options] [folder]\n";
                sleep(1);
                goto retry;
            }
        }else{
            file = true;
            path = buff;
        }
        num = 0;
        out = "";
    }
    bool get(frame* f){
        char b1[100];
        char b2[100];
        float* data;
        if(file){
            sprintf(b1,"%s/%d.rawdata",path,num);
            sprintf(b2,"%s/%d.jpg",path,num);
            //cout << b1 << endl << b2 << endl;
            f->rgb = imread(b2);     
            data = readFloatFile(b1,640*480*3);
            f->d = Mat(480,640,CV_32FC3,data);
            if(f->rgb.empty() || f->d.empty()){
                cerr << "Error reading kinect frame!\n";
                return false;
            }
        }else{
            capture.grab();
            capture.retrieve( f->d, CV_CAP_OPENNI_POINT_CLOUD_MAP );
            capture.retrieve( f->rgb, CV_CAP_OPENNI_BGR_IMAGE );
        }
        if(out != ""){
            sprintf(b1,"%s/%d.rawdata",out.c_str(),num);
            sprintf(b2,"%s/%d.jpg",out.c_str(),num);
            //cout << b1 << endl;
            imwrite(b2,f->rgb);
            writeFloatFile(b1,640*480*3,(float*)f->d.data);
            //imwrite(b1,f->d);
            //d.save(b1);
        }
        //depth.convertTo( f->d, CV_32FC1, 1./1000 );
        //depth.release();
        num++;
        return true;
    }
    void set_output(string dir){
        out = dir;
        //clean(dir.c_str());
    }
};

#endif