#ifndef POINT2D_H
#define POINT2D_H

#include <fstream>
#include <iostream>
#include "math.h"


using namespace std;

class Point2D{
    public:
    
    union{
        struct{
        float x,y;
        };
        float data[2];
    };
    Point2D(){}
    
    Point2D(float X,float Y):x(X),y(Y){
    
    }
    
    float distance(Point2D* p){
        return pow(this->x-p->x,2)+pow(this->y-p->y,2);
    }
    
    void print(){
        cout << "("<< x << "," << y << ")\n";
    }

    float& operator [] (int i){
        return data[i];
    }

    void save(ofstream& f){
        f.write((char*)&data[0],sizeof(float)*2);
    }
};

Point2D* loadPoint2D(ifstream& f){
    Point2D* res = new Point2D;
    f.read((char*)&res->data[0],sizeof(float)*2);
    return res;
}

struct Point2DInt{
    int x,y;
};

class Transformation2D{
    public:
    
    float seno,coseno,tx,ty,angolo;
    
    Transformation2D():tx(0),ty(0),angolo(0),seno(0),coseno(1){}

    Transformation2D(float* ptr){
        tx = ptr[0];
        ty = ptr[1];
        seno = sin(ptr[2]);
        coseno = cos(ptr[2]);
    }
    
    void copy(Transformation2D* o){
        this->tx = o->tx;
        this->ty = o->ty;
        this->angolo = o->angolo;
        this->seno = o->seno;
        this->coseno = o->coseno;
    }

    void trigo(){
        seno = sin(angolo);
        coseno = cos(angolo);
    }
    
    void print(){
        cout << "Rotazione antioraria: " << angolo*180.0/PI  << " seno: " << seno << " coseno:" << coseno << " traslazione x: " << tx << " y: " << ty << endl;
    }

    void transform(Point2D* src,Point2D* dst){
        dst->x = tx + src->x*this->coseno - src->y*this->seno;
        dst->y = ty + src->x*this->seno + src->y*this->coseno;
    }

    void transform(Point2D* src,Point2DInt* dst,float scale,float centerX,float centerY,int sizeX,int sizeY){
        dst->x = (tx + src->x*this->coseno - src->y*this->seno + centerX)*scale  + sizeX/2;
        dst->y = sizeY/2 - (ty + src->x*this->seno + src->y*this->coseno + centerY)*scale;
    }

    void transform(Point2D* src){
        float x = tx + src->x*this->coseno - src->y*this->seno;
        src->y = ty + src->x*this->seno + src->y*this->coseno;
        src->x = x;
    }
};

Transformation2D* IDENTITY_2D = new Transformation2D();

#endif