#ifndef SHARED_MEM_H
#define SHARED_MEM_H

#include <sys/ipc.h>
#include <sys/shm.h>
#include <signal.h>


class SharedMemServer;
class SharedMemClient;

vector<SharedMemClient*>runningClients;
vector<SharedMemServer*>runningServers;

class SharedMemServer{
    public:

    int mem_id;
    unsigned char* sem;
    char* shm;
    bool real;

    SharedMemServer(int key,int size){
        if(key == -1){
            real = false;
            shm = (char*)malloc(size);
        }else{
            real = true;
            mem_id = shmget(key,size+sizeof(char),IPC_CREAT | 0666);
            shm = (char*)shmat(mem_id,NULL,0);
            
            sem = (unsigned char*)shm;
            *sem = 0;
            shm += sizeof(char);
            runningServers.push_back(this);
        }
    }

    void send(){
        if(real){
            (*sem)++;
            if((*sem) == 200)(*sem) = 0;
        }
    }

    void close(){
        if(real)shmctl(mem_id, IPC_RMID, NULL);
    }
};

class SharedMemClient{
    public:

    int mem_id;
    unsigned char* sem;
    unsigned char old;
    char* shm;

    SharedMemClient(int key,int size){
        get:
        mem_id = shmget(key,size+sizeof(unsigned char),0666);
        if(mem_id == -1){
            cout << "shmget fail retry\n";
            usleep(200*1000);
            goto get;
        }
        shm = (char*)shmat(mem_id,NULL,0);
        if(shm == NULL){
            cout << "shmget fail attach\n";
            usleep(200*1000);
            goto get;
        }
        sem = (unsigned char*)shm;
        shm += sizeof(unsigned char);
        old = 0;
    }

    /*void lock(){
        sem_wait(sem);
    }

    void unlock(){
        sem_post(sem);
    }*/

    void wait(){
        while(old == *sem){
            usleep(1000);
        }
        old = *sem;
    }

    void close(){
        shmctl(mem_id, IPC_RMID, NULL);
    }   
};

void sighandler(int s){
    cout << "Close\n";
    for (int i = 0; i < runningServers.size(); ++i)
    {
        runningServers[i]->close();
    }
    for (int i = 0; i < runningClients.size(); ++i)
    {
        runningClients[i]->close();
    }
    exit(0);
}

void sharedMemoryInit(){
    signal(SIGINT, sighandler);
}

#endif
