#ifndef STATISTIC_H
#define STATISTIC_H

#include <stdlib.h>
#include <time.h>

#define withProbability(a) if((float)rand()/RAND_MAX <= a) 
#define randChose(prob,f,s) ((float)rand()/RAND_MAX <= prob)?f:s


void initRand(){
    srand(time(NULL));
}

template<class t>t randRange(t min,t max){
    if(min >= max) return min;
    if(t(0.6) == 0)return min + (rand() % (int)(max - min + 1));
    else return min + t((float)rand()*(max-min)/(RAND_MAX));
}

template<class t>t realisticError(t var,t sigma){
    return var + sigma*pow(randRange<t>(-1,1),3);
}

template<class t>t gaussian(t mu,t sigma,t x){
    return exp(    -pow(x-mu,2) / (2*pow(sigma,2))    );
}

#endif