#ifndef TIME_H
#define TIME_H

#include <unistd.h>
#include <sys/time.h>
#include "console.h"

class Stopwatch{
    timeval s,e;
    bool started;
    double tot;
    int num;
    public:
    Stopwatch(){
        tot = 0;
        num = 0;
        started = false;
    }
    void tick(){
        if(started){
            started = false;
            gettimeofday(&e, NULL);
            tot += ((e.tv_sec  - s.tv_sec) * 1000.0 + (e.tv_usec - s.tv_usec)/1000.0);
            num++;
        }else{
            gettimeofday(&s, NULL);
            started = true;
        }
    }
    
    double time(){
        return tot;
    }
    
    double lapTime(){
        if(num == 0) return tot;
        return tot/num;
    }
};


template<class t>void sleep (t ms){
	usleep(ms*1000);
}

unsigned long timeInMicroseconds(){
    timeval s;
    gettimeofday(&s, NULL);
    return 1000000 * s.tv_sec + s.tv_usec;
}

class Fps{
    public:

    unsigned long w,t;

    Fps(unsigned long fps){
        w = (1000*1000)/fps;
        t = timeInMicroseconds();
        this->wait();
    }

    void wait(){
        unsigned long act = timeInMicroseconds()-t;
        if(act < w){
            usleep(w-act);
        }else{
            cout << CONSOLE_YELLOW << "Drawing too slow can only achieve: " << (1000*1000)/act << "fps" << CONSOLE_RESET << endl;
        }
        t = timeInMicroseconds();
    }    
};  

#endif