var http_server = require('http').createServer(http_handler),
    static = require('static-folder').init("static"),//select the folder that contains the files
    spawn = require('child_process').spawn,
    fs = require('fs'),
    walk = function(dir, done) {
  var results = [];
  fs.readdir(dir, function(err, list) {
    if (err) return done(err);
    var pending = list.length;
    if (!pending) return done(null, results);
    list.forEach(function(file) {
      file = dir + '/' + file;
      fs.stat(file, function(err, stat) {
        if (stat && stat.isDirectory()) {
          walk(file, function(err, res) {
            results = results.concat(res);
            if (!--pending) done(null, results);
          });
        } else {
          results.push(file);
          if (!--pending) done(null, results);
        }
      });
    });
  });
};

var docs = [];

walk("docs", function(err, results) {
  if (err) throw err;
  docs = results;
});

function makeLinks(line){
    return line.replace(/\[[a-zA-Z0-9.]+\]/g,function(s){
        s = s.substr(1,s.length-2);
        for (var i = 0; i < docs.length; i++) {
            var parts = docs[i].split("/");
            if(parts[parts.length-1] == s)return "<a href='/"+docs[i]+"'>"+s+"</a>";
        };
    });
}

function render(res,name){
    res.writeHead(200,{"Content-Type": "text/html"});
    res.write('<link rel="stylesheet" href="/static/highlight/styles/default.css"><script src="/static/highlight/highlight.pack.js"></script><script>hljs.initHighlightingOnLoad();</script>')


    var lines = fs.readFileSync(name).toString().split("\n");
    for (var i = 0; i < lines.length; i++){
        var line = lines[i];

        if(line[line.length-1] == "\n")line = line.substr(0,line.length-1);
        
        if(line == ""){
            res.write("<br>");
            continue;
        }

        var title = 0;
        while(line[title] == "=")title += 1;
        if(title > 0){
            line = line.substr(title,line.length-title);
            title = String(4-title);
            res.write("<h"+title+">"+line+"</h"+title+">");
            continue;
        }
        if(line == "{{{"){
            res.write("<pre><code>")
            i++;
            while(lines[i] != "}}}"){
                line = lines[i];
                res.write(line+"<br>");
                i++;
            }
            res.write("</code></pre>");
            continue;
        }
        /*if(line == "}}}"){
            res.write("</code></pre>");
            continue;        
        }*/
        res.write(makeLinks(line)+"<br>");

    }
    res.end();
}

function http_handler(req,res){
    var url = static.splitUrl(req);
    switch(url[0]){
        case "static":
            url.shift();
            url = url.join("/");
            static.send(res,url);
            break;
        case "docs":
            url = url.join("/"); 
            render(res,url);           
            break;
        default:
          render(res,"docs/index");
          break;
    }
}

http_server.listen(8080);