#include "../Include/roshbot.h"
#include <iostream>


using namespace std;

class Pixel{
	public:

	int x,y;

	Pixel(int i,int j):x(i),y(j){
	}

	int distance(Pixel& o){
		//return abs(this->x-o.x);
		//return pow(this->x-o.x,2)+pow(this->y-o.y,2);
		return abs(this->x-o.x)+abs(this->y-o.y);
	}	
};

bool isVoronoi(vector<Pixel>&world,Pixel& p){
	int d = 96000;
	int voronoi = 1;
	for(int a = 0;a < world.size();a++){
		//if(world[a].y == p.y){
			int dist = p.distance(world[a]);
			if(dist < d){
				d = dist;
				voronoi = 1;
				dist = -1;
			}
			if(d == dist){
				voronoi++;
			}
		//}
	}
	return  voronoi > 1;
}

int main(int argc,char** argv){
	namedWindow("A",CV_WINDOW_NORMAL);
	namedWindow("contours",CV_WINDOW_NORMAL);
	namedWindow("voronoi",CV_WINDOW_NORMAL);


	Mat img = imread("a.png",0);
	uchar* ptr = img.data;
	Mat contours(1000,1000,CV_8UC3);
	uchar* contoursPtr = contours.data;
	for(int a = 0;a < 1000*1000*3;a++){
		contoursPtr[a] = 0;
	}
	//Mat voronoi(1000,1000,CV_8UC1);
	//uchar* voronoiPtr = voronoi.data;	

	vector<Pixel>contourPoints;

	for(int a = 0;a < 50;a++){
		for(int b = 0;b < 50;b++){
			if(a != 49 && b != 0 && (ptr[b*50+a] != ptr[b*50+a+1] || ptr[b*50+a] != ptr[(b-1)*50+a])){
				contoursPtr[b*20*1000*3+a*20*3+2] = 255;
				contourPoints.push_back(Pixel(a*20,b*20));
			}else{
				contoursPtr[b*20*1000*3+a*20*3+2] = 0;
			}
		}
	}

	for(int a = 0;a < 1000;a++){
		for(int b = 0;b < 1000;b++){
			Pixel p(a,b);
			if(isVoronoi(contourPoints,p)){
				contoursPtr[b*1000*3+a*3+1] = 255;
			}else{
				contoursPtr[b*1000*3+a*3+1] = 0;
			}
		}
	}

	imshow("A",img);
	imshow("contours",contours);
	//imshow("voronoi",voronoi);

	waitKey(0);
	return 0;
}