#include "../Include/roshbot.h"
#include "../Include/communication.h"
#include <iostream>


using namespace std;


/*argv
	0: program name
input ports
	1: image
out ports
	2: joystick
settings
	3: server port
parent settings
	4: frame width
	5: frame height
*/
int main(int argc,char** argv){
	sharedMemoryInit();
	int port = atoi(argv[3]);
	int width = atoi(argv[4]);
	int height = atoi(argv[5]);
	cout << width << " " << height << endl;
	SharedMemClient cli(atoi(argv[1]),sizeof(uchar)*width*height*3);
	SharedMemServer joystick(atoi(argv[2]),sizeof(float)*2);

	Mat img(height,width,CV_8UC3,cli.shm);

	Server server(port);
	server.waitConnection();
	float* joy = (float*)joystick.shm; //new float[2];

	cout << "Up and running!\n";

	while(1){
		//get image
		cli.wait();
		//encode image
		std::vector<uchar> v;
		imencode(".jpg",img,v);
		//send image size
		int s = v.size();
		server.write((char*)&s,sizeof(int));
		//read joystick data
		server.write((char*)&v[0],s);
		//send joystick data
		server.read((char*)&joy[0],sizeof(float)*2);
		joystick.send();
		cout << joy[0] << " " << joy[1] << endl;
		//usleep(10*1000);
		//if(keypress())break;
	}

	server.close();

	return 0;
}