#include "../Include/roshbot.h"
#include <iostream>


using namespace std;

class Joystick{
	public:

	float x,y;
	SDL_Joystick* joy;
	float min,max;

	Joystick(float Min = 0.6,float Max = 1.0):joy(NULL),x(0),y(0),min(Min),max(Max){
		SDL_InitSubSystem(SDL_INIT_JOYSTICK);
		if(SDL_NumJoysticks() < 1){
			cout << CONSOLE_RED << "Error no joystick found\n" << CONSOLE_RESET;
		}else{
			joy = SDL_JoystickOpen ( 0 );
			SDL_JoystickEventState ( SDL_QUERY );
		}
	}

	void update(){
		SDL_JoystickUpdate();
		if(joy == NULL){
			cout << CONSOLE_RED << "Error no joystick\n" << CONSOLE_RESET;
		}else{
			float s = (32767.0-SDL_JoystickGetAxis(joy,2))/65534.0;
			//cout << s << endl;
			float speed = min+(max-min)*s;
			x = signedSquare(SDL_JoystickGetAxis(joy,0)/32767.3)*speed;
			y = signedSquare((-SDL_JoystickGetAxis(joy,1))/32767.3)*speed;
		}
	}
};

int main(int argc,char** argv){
	Joystick joy;
	while(1){
		joy.update();
		float variance = 1.0-abs(joy.y);
		char l = 127*(joy.y+joy.x*variance);
		char r = 127*(joy.y-joy.x*variance);
		cout << (int)l << " " << (int)r << endl;
	}
}