var http_server = require('http').createServer(http_handler),
    static = require('static-folder').init("static"),//select the folder that contains the files
    spawn = require('child_process').spawn,
    fs = require('fs'),
    manager = require('./modules/node_manager').init();

Array.prototype.diff = function(a) {
    return this.filter(function(i) {return !(a.indexOf(i) > -1);});
};

console.log("\033[92m Node.js server acess it at http://localhost:8080/\033[0m")


var running = [];

function puts(error, stdout, stderr) { console.log(stdout) }

function run(command,args){
    console.log("run "+command+" "+args);
    var cmd = "../"+command+"/main";
    var p = spawn(cmd,args.split(" "));
    p.stdout.on("data",function(d){
        console.log(command+": "+d.toString());
    });
    running.push(p);
}

function stop(){
    for (var i = 0; i < running.length; i++) {
        console.log(running[i].kill("SIGINT"));
    };
    running = [];
}

function kill(){
    run("killall","-9 main");
}

function http_handler(req,res){
    var url = static.splitUrl(req);
    switch(url[0]){
        case "static":
            static.send(res,url[1]);
            break;
        case "run":
        	stop();
        	var end = url.length;
        	for (var i = 1; i < end; i+=2) {
                run(decodeURIComponent(url[i]),decodeURIComponent(url[i+1]));
        	};
        	res.end();
        	break;
        case "stop":
            stop();
            res.end();
            break;
    	case "kill":
    		kill();
    		res.end();
    		break;
        case "list":
            res.end(JSON.stringify(manager.nodes));
            break;
        default:
        	static.send(res,"index.html");
        	break;
    }
}

http_server.listen(8080);
