Array.prototype.diff = function(a) {
    return this.filter(function(i) {return !(a.indexOf(i) > -1);});
};

function $halt(ev) {
    ev.preventDefault();
    ev.stopPropagation();
}

function $get(theUrl)
{
	console.log(theUrl);
    var xmlHttp = null;

    xmlHttp = new XMLHttpRequest();
    xmlHttp.open( "GET", theUrl, false );
    xmlHttp.send( null );
    return xmlHttp.responseText;
}

function $random(len){
	return Math.random().toString(36).substr(2,len);
}

HTMLElement.prototype.unshift = function(el){
	if(this.childNodes.length > 0){
		this.insertBefore(el,this.childNodes[0]);
	}else{
		this.appendChild(el);
	}
}

var Dragger = {
	init: function(node,ev,moving,end){
		$halt(ev);
		Dragger.node = node;
		Dragger.moving = moving;
		Dragger.end = end;
		Dragger.data = null;
		node.style.zIndex = 4;
		Dragger.x = parseInt(node.style.left) - ev.x;
		Dragger.y = parseInt(node.style.top) - ev.y;
		document.body.onmousemove = Dragger.move;
		node.onmouseout = function(){$halt(event);};
		document.body.onmouseup = Dragger.up;

	},

	move: function(ev){
		$halt(ev);
		/*Dragger.node.setX(Dragger.x +ev.x);
		Dragger.node.setY(Dragger.y +ev.y);*/
		Dragger.moving(Dragger.x +ev.x,Dragger.y +ev.y);
	},

	up: function(ev){
		$halt(ev);
		if(Dragger.node){
			if(Dragger.end){
				Dragger.end(Dragger.x +ev.x,Dragger.y +ev.y,Dragger.data);
			}
			Dragger.node.style.zIndex = 2;
			Dragger.node.onmouseup = null;
			document.body.onmousemove = null;
			Dragger.node = null;
			Dragger.data = null;
		}
	}
};

var Canvas = function(name){
      this.canvas = document.getElementById(name);
      this.canvas.width = this.canvas.offsetWidth;
      this.canvas.height = this.canvas.offsetHeight;

      this.ctx = this.canvas.getContext('2d');

      //this.lines = Array();
	}

Canvas.prototype = {
	join: function(x,y,x1,y1){
		var delta = Math.abs(x1-x)/2;
		this.ctx.beginPath();
		this.ctx.moveTo(x, y);
		this.ctx.bezierCurveTo(x+delta, y, x1-delta, y1, x1, y1);
		this.ctx.lineWidth = 10;
		this.ctx.strokeStyle = 'hsl(184, 49%, 51%)';
		this.ctx.stroke();
	},

	clear: function(){
		this.ctx.clearRect(0,0,this.canvas.width,this.canvas.height);
	},

	/*draw: function(){
		for (var i = 0; i < this.lines.length; i++) {
			this.lines[i].draw(this);
		}
	},*/
};

var Line = function(l,x,y,x1,y1){
	this.level = l;
	this.x = x;
	this.x1 = x1;
	this.y = y;
	this.y1 = y1;	
}

Line.prototype = {
	moveStart: function(x,y){
		this.x = x;
		this.y = y;
		this.draw(current);
	},

	moveEnd: function(x,y){
		this.x1 = x;
		this.y1 = y;
		this.draw(current);
	},	

	draw: function(canvas){
		canvas.join(this.x,this.y,this.x1,this.y1);
	},
};

var DualCanvas = {
	init: function(s,d){
		DualCanvas.static = new Canvas(s);
		DualCanvas.dinamic = new Canvas(d);
		DualCanvas.lines = [];
	},
	fix: function(){//fix dinamic into static
		DualCanvas.dinamic.clear();
		for (var i = 0; i < DualCanvas.lines.length; i++) {
			if(DualCanvas.lines[i].level == 1){//if line on static
				DualCanvas.lines[i].level = 0;
				DualCanvas.lines[i].draw(DualCanvas.static);
			}
		};
	},
};