import os
import readline
import inspect



def wrapper(fun,param):
    return fun(*param)

class ConsoleAction:
    def __init__(self,name,params,usage,callback):
        self.name = name
        self.params = params
        self.usage = usage
        self.callback = callback
        self.sn = len(self.name)
        self.sp = len(self.params)

    def getStr(self,SN,SP):
        res = '\033[92m' + self.name
        for a in range(SN-self.sn):
            res = res + " "
        res = res + "\033[96m" + self.params
        for a in range(SP-self.sp):
            res = res + " "
        return res + "\033[0m" + self.usage
        

class Console:
    def __init__(self,s = "> "):
        self.string = s
        self.actions = list()
        self.sn = 2
        self.sp = 7
    def addCommand(self,name,params,usage,cb = 0):
        act = ConsoleAction(name,params,usage,cb)
        self.actions.append(act)
        self.sn = max(self.sn,act.sn+2)
        self.sp = max(self.sp,act.sp+3)
    def Run(self):
        input = raw_input("> ")
        cmds = input.split(" ")
        if cmds[0] == "exit":
            return -1
        for a in self.actions:
            if a.name == cmds[0]:
                cmds.pop(0)
                if len(cmds) == 0 and len(inspect.getargspec(a.callback).args) != 0:
                    print a.getStr(self.sn,self.sp)
                else:
                    wrapper(a.callback,cmds)
                return 0
        print "Available commands:"
        for a in self.actions:
            print a.getStr(self.sn,self.sp)
        self.printExit()
        return 1
    def printExit(self):
        res = "\033[92mexit\033[0m"
        for a in range(self.sp+self.sn-4):
            res += " "
        print res + "Close this console"
    def run(self):
        state = 0
        while state != -1:
            state = self.Run()
