#include "../Include/roshbot.h"
#include <iostream>


using namespace std;

class MD49{
	public:

	Serial ser;
	char cmd[3];

	MD49(char * port):ser(port,38400){
		cmd[0] = 0x00;
		cmd[1] = 0x38;//disable timeout
		ser.write(cmd,2);
		cmd[1] = 0x37;//enable pid
		ser.write(cmd,2);		
	}

	void setMode(char mode){
		cmd[1] = 0x34;
		cmd[2] = mode;
		ser.write(cmd,3);
	}

	int getVolts(){	
		cmd[1] = 0x26;
		ser.write(cmd,2);
		char res;
		ser.read(res,1);
		return res;
	}

	void setSpeed(char speed,char side){
		cmd[1] = (side == 0)?0x31:0x32;
		cmd[2] = speed;
		ser.write(cmd,3);
	}

	void resetEncoders(){
		cmd[1] = 0x35;
		ser.write(cmd,2);
	}

	int getEncoder(char n = 0){
		cmd[1] = (n == 0)?0x23:0x24;
		ser.write(cmd,2);
		int result;
		result =  ser.getChar() << 24ul;    // (0x00 shifted 24 bits left) 
		result += ser.getChar() << 16ul;    // (0x10 shifted 16 bits left) 
		result += ser.getChar() << 8ul;     // (0x56 shifted 8 bits left) 
		result += ser.getChar();            //  (0x32) 
		return result;
	}

	float getAmps(char n = 0){
		cmd[1] = (n == 0)?0x27:0x28;
		ser.write(cmd,2);
		return serin()/10.0;
	}
};

int main(int argc,char** argv){
	MD49 motors("/dev/ttyUSB1");
	cout << "Input voltage: " << motors.getVolts() << endl;
	motors.setMode(2);
	motors.resetEncoders();
	while(1){
		motors.setSpeed(200);
		cout << motors.getEncoder() << endl;
		cout << motors.getAmps() << endl;
		sleep(1);
	}
	/*Serial ser("/dev/ttyUSB1",38400);
	char cmd[3];
	cmd[0] = 0x00;
	cmd[1] = 0x26;
	//cmd[2] = 3;
	//cmd[2] = 200;
	ser.write(cmd[0],2);
	//while(1){
		char speed;
		ser.read(speed,1);
	cout << int(speed) << endl;
		/*cin >> speed;
		if(speed == 0)return 0;
		cmd[1] = 0x31;
		cmd[2] = speed;	
		ser.write(cmd[0],3);*/
	//}

//sleep(10);
	/*uchar res;
	ser.read(res,1);
	cout << int(res) << endl;*/
	return 0;
}