#include "../Include/roshbot.h"
#include <iostream>


using namespace std;

class Odometry{
	public:

	double wheel_d;
	double x,y,phi;

	Odometry(double d):wheel_d(d),x(0),y(0),phi(0){
	}

	void update(double speed_s,double speed_d){
		//cout << speed_s << " " << speed_d << endl;
		if(speed_s == speed_d){
			x -= speed_s*sin(phi);
			y += speed_s*cos(phi);
		}else{
			double alpha = (speed_d-speed_s)/wheel_d;
			double r;

			if(speed_s < speed_d){
				r = -speed_s/tan(alpha) - wheel_d/2;
			}else{
				r = -speed_s/tan(alpha) - wheel_d/2;
			}
			//r = speed_s/tan(alpha);// - wheel_d/2;
			//if(speed_s < speed_d)r *= -1;
			//cout << alpha << " " << r << endl;

			double center_x = x + r*cos(phi);
			double center_y = y + r*sin(phi);
			//cout << center_x << " " << center_y << endl;

			double X = center_x + (x - center_x)*cos(alpha) -(y - center_y)*sin(alpha);
			y = center_y + (x - center_x)*sin(alpha) +(y - center_y)*cos(alpha);
			x = X;
			phi += alpha;

			//cout << pow(x-0.22,2)+y*y << endl;
		}
	}	
};

int main(int argc,char** argv){
	Space space("Poligoni",800,800);
	Point2D* points = new Point2D[8];
	points[0] = Point2D(0.24,-0.065);
	points[1] = Point2D(-0.24,-0.065);
	points[2] = Point2D(-0.24,0.065);
	points[3] = Point2D(-0.20,0.065);
	points[4] = Point2D(-0.20,0.335);
	points[5] = Point2D(0.20,0.335);
	points[6] = Point2D(0.20,0.065);
	points[7] = Point2D(0.24,0.065);

	Poligon* poli = new Poligon(points,8); 
	space.poligons.push_back(poli);

	Joystick joy(0.01,0.1);

	float centro[] = {0.22,0};
	space.points.push_back(centro);

	Odometry odo(0.44);
	space.draw();
	Fps fps(30);
        
    bool ok = true;
    while(ok){
    	fps.wait();
    	ok = space.draw();
    	joy.update();
    	//cout << joy.x << " " << joy.y << endl;
    	odo.update(joy.y+joy.x/10,joy.y-joy.x/10);
    	//odo.update(0.001,0.003);

    	poli->t->angolo = odo.phi;
    	poli->t->tx = odo.x;
    	poli->t->ty = odo.y;
    	//poli->t->ty += 0.001;//realisticError(0.0,0.1);
    	poli->t->trigo();
    }
	return 0;
}