#include "../Include/roshbot.h"
#include <iostream>

using namespace std;



//line position map
int main(int argc,char** argv){
    sharedMemoryInit();
    SharedMemClient line(atoi(argv[1]),sizeof(float)*640*3);
    SharedMemServer position(atoi(argv[2]),sizeof(float)*3);
    float* pos = (float*)position.shm;
    
    Space p("plot",800,800);
    cout << "Up and running\n";

    //get a frame
    line.wait();

    //init slam
    kinectLineSlam slam;
    slam.setReference((float*)line.shm);

    Transformation2D* t = new Transformation2D;
    Stopwatch watch;
    //set plot agent to origin
    p.setAgent(t->tx,t->ty,t->angolo+PI/2.0);
    //add first mesure
    for(int a = 0;a < slam.points.size();a++){
        p.addPoint((float*)slam.points[a]);
    }
    p.draw();
    int a;
    for(a = 0;true;a++){
        //get frame
        line.wait();
        //get new line and apply current transformation
        watch.tick();
        //add new mesure to slam
        slam.addMesure((float*)line.shm,t);
        //get current transformation from slam
        t->copy(slam.t);
        //apply current transformation to slam
        slam.applyTransformation(t);
        //print current transformation
        t->print();
        //set agent to new position
        pos[0] = t->tx; pos[1] = t->ty; pos[2] = t->angolo;
        position.send();
        p.setAgent(t->tx,t->ty,t->angolo);
        //draw new points
        for(int a = 0;a < slam.points.size();a+=5){
            p.addPoint((float*)slam.points[a]);
        } 
        watch.tick();
        cout << "Lap Time: " << watch.lapTime() << " FPS: " << 1000.0/watch.lapTime() << endl;
        if(!p.draw())break;
        if(waitKey(1) > 0)break;
    }

    temporary:
        cout << "END!\n";
        slam.saveMap(argv[3]);
        cout << "Total time: " << watch.time() << " Number of frames: " << a << endl;
        for(a = 0;true;a++){
            sleep(1.0);
        }
}